﻿Imports System
Imports System.IO
Imports System.Collections
Imports System.Runtime.Serialization.Formatters.Binary
Imports System.Runtime.Serialization

Public Class Form1

    Dim GlobeNodes As New ArrayList()
    Private Sub BtnAddNode_Click(sender As Object, e As EventArgs) Handles btnAddNode.Click
        Dim N As String
        N = tbxInput.Text

        If tvwRoadmap.SelectedNode Is Nothing Then
            tvwRoadmap.Nodes.Add(N, N)
        Else
            tvwRoadmap.SelectedNode.Nodes.Add(N, N)
        End If
    End Sub

    Private Sub BtnExit_Click(sender As Object, e As EventArgs) Handles btnExit.Click
        Application.Exit()
    End Sub

    Private Sub btnDeleteNode_Click(sender As Object, e As EventArgs) Handles btnDeleteNode.Click
        tvwRoadmap.SelectedNode.Remove()
    End Sub

    Private Sub BtnNodeUp_Click(sender As Object, e As EventArgs) Handles btnNodeUp.Click
        Dim selectedNode As TreeNode = Me.tvwRoadmap.SelectedNode
        Dim targetIndex As Integer = selectedNode.Index - 1

        If targetIndex >= 0 Then
            Dim nodeFamily As TreeNodeCollection

            If selectedNode.Parent Is Nothing Then
                nodeFamily = Me.tvwRoadmap.Nodes
            Else
                nodeFamily = selectedNode.Parent.Nodes
            End If

            nodeFamily.Remove(selectedNode)
            nodeFamily.Insert(targetIndex, selectedNode)
        End If
        Me.tvwRoadmap.SelectedNode = selectedNode
    End Sub

    Private Sub BtnNodeDown_Click(sender As Object, e As EventArgs) Handles btnNodeDown.Click
        Dim selectedNode As TreeNode = Me.tvwRoadmap.SelectedNode
        Dim targetIndex As Integer = selectedNode.Index + 1

        If targetIndex >= 0 Then
            Dim nodeFamily As TreeNodeCollection

            If selectedNode.Parent Is Nothing Then
                nodeFamily = Me.tvwRoadmap.Nodes
            Else
                nodeFamily = selectedNode.Parent.Nodes
            End If

            nodeFamily.Remove(selectedNode)
            nodeFamily.Insert(targetIndex, selectedNode)
        End If
        Me.tvwRoadmap.SelectedNode = selectedNode
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

    End Sub

    <Serializable()> Structure sNode
        Dim node As String
        Dim level As Integer
    End Structure

    Private Sub BtnWrite_Click(sender As Object, e As EventArgs) Handles btnWriteXML.Click
        SaveFileDialog1.DefaultExt = "XML"
        If SaveFileDialog1.ShowDialog = DialogResult.OK Then
            GlobeNodes.Clear()
            CreateList(tvwRoadmap.Nodes(0), SaveFileDialog1.FileName)
        End If
    End Sub

    Private Sub btnLoadXML_Click(sender As Object, e As EventArgs) Handles btnLoadXML.Click
        tvwRoadmap.Nodes.Clear()
        OpenFileDialog1.DefaultExt = "XML"
        If OpenFileDialog1.ShowDialog = DialogResult.OK Then
            GlobeNodes.Clear()
            LoadNodes(tvwRoadmap, OpenFileDialog1.FileName)
        End If
        tvwRoadmap.Refresh()
    End Sub

    Sub CreateList(ByVal node As TreeNode, ByVal fName As String)
        Static level As Integer
        Dim thisNode As TreeNode
        Dim myNode As sNode
        Application.DoEvents()
        myNode.level = level
        myNode.node = node.Text
        GlobeNodes.Add(myNode)
        If node.Nodes.Count > 0 Then
            level = level + 1
            For Each thisNode In node.Nodes
                CreateList(thisNode, fName)
            Next
            level = level - 1
        End If
        SaveNodes(fName)
    End Sub

    Sub LoadNodes(ByVal TV As TreeView, ByVal fName As String)
        'Clear All Nodes from TreeView
        tvwRoadmap.Nodes.Clear()
        Dim formatter As BinaryFormatter
        Dim openFile As FileStream
        openFile = File.Open(fName, FileMode.Open)
        formatter = New BinaryFormatter
        GlobeNodes = CType(formatter.Deserialize(openFile), ArrayList)
        openFile.Close()
        showNodes(TV)
    End Sub

    Sub showNodes(ByVal TV As TreeView)
        Dim o As Object
        Dim currNode As TreeNode = Nothing
        Dim level As Integer = 0

        Dim i As Integer
        For i = 0 To GlobeNodes.Count - 1
            o = GlobeNodes(i)
            Dim oNode As sNode = CType(o, sNode)
            If CType(oNode, sNode).level = level Then
                If currNode Is Nothing Then
                    currNode = TV.Nodes.Add(oNode.node.ToString)
                Else
                    currNode = currNode.Parent.Nodes.Add(oNode.node.ToString)
                End If
            Else
                If oNode.level > level Then
                    currNode = currNode.Nodes.Add(oNode.node.ToString)
                    level = oNode.level
                Else
                    While oNode.level <= level
                        currNode = currNode.Parent
                        level = level - 1
                    End While
                    currNode = currNode.Nodes.Add(oNode.node.ToString)
                End If
            End If
            TV.ExpandAll()
            Application.DoEvents()
        Next
    End Sub

    Sub SaveNodes(ByVal fName As String)
        Dim formatter As BinaryFormatter
        Dim saveFile As FileStream
        saveFile = File.Create(fName)
        formatter = New BinaryFormatter
        formatter.Serialize(saveFile, GlobeNodes)
        saveFile.Close()
    End Sub

    Private Sub tbxInput_KeyUp(sender As Object, e As KeyEventArgs) Handles tbxInput.KeyUp

        If e.KeyCode = Keys.Return Then
            e.SuppressKeyPress = True
            Dim N As String
            N = tbxInput.Text

            If tvwRoadmap.SelectedNode Is Nothing Then
                tvwRoadmap.Nodes.Add(N, N)
            Else
                tvwRoadmap.SelectedNode.Nodes.Add(N, N)
            End If
            ' Expand Tree
            tvwRoadmap.ExpandAll()
            tbxInput.Text = ""
        End If
    End Sub

    Private Sub tbxInput_KeyPress(sender As Object, e As KeyPressEventArgs) Handles tbxInput.KeyPress
        If e.KeyChar = Chr(Keys.Return) Then
            e.Handled = True
        End If
    End Sub

    Private Sub BtnClear_Click(sender As Object, e As EventArgs) Handles btnClear.Click
        tvwRoadmap.Nodes.Clear()
        tvwRoadmap.Refresh()
    End Sub

    Private Sub pnlCircularView_Paint(sender As Object, e As PaintEventArgs) Handles pnlCircularView.Paint
        Dim x0, y0 As Integer
        Dim R1 As Integer = 100
        Dim R2 As Integer = 150
        x0 = (pnlCircularView.Width / 2) - R2
        y0 = (pnlCircularView.Height / 2) - R2
        e.Graphics.DrawArc(Pens.Blue, x0, y0, R1, R1, 0, -90)
        e.Graphics.DrawArc(Pens.Blue, x0, y0, R2, R2, 0, -90)
    End Sub
End Class
